#!/bin/bash

# given a collection of pairs - find BIM between them
if [ $# -lt 3 ]; then
	echo "Usage: "
	echo "	./RunBIMBatch pairs.txt maxDist runJobsAs=[qsubEach execOneByOne]"
	echo ""
	exit
fi

if [ $# -ge 3 ]; then
	runJobsAs="$3"
fi

scriptDir=`dirname $0`
dataDir=`dirname $1`

n=0
a=$1
d=$2
prev="";
for i in `cat ${a}` ; do
	if [ $n -eq 0 ]; then
		let n=1
	elif [ $n -eq 1 ]; then
		prev=${i}
		let n=2
	elif [ $n -eq 2 ]; then
		echo $prev" -> "${i}
		f1="./$dataDir/$prev/$prev.ply"
		f2="./$dataDir/${i}/${i}.ply"
		let n=1
		if [ $runJobsAs == "qsubEach" ]; then
			tempScriptsDir=$dataDir"/TempScripts/"
			if [ ! -d $tempScriptsDir ]; then
				mkdir $tempScriptsDir
			fi
			prefix=$tempScriptsDir/$prev"_to_"${i}.qsub
			outLog=$prefix.log
			outErr=$prefix.err
			scriptName=$prefix.sh
			echo "#!/bin/bash" > $scriptName
			echo "$scriptDir/BlendedIntrinsicMaps.sh $f1 $f2 $d ./$dataDir/" >> $scriptName
			qsubParams="-l mem=4000mb,cput=8:00:00 -N $prev""_to_${i} -d `pwd` -o $outLog -e $outErr" 
			qsub $qsubParams $scriptName
		else
			$scriptDir/BlendedIntrinsicMaps.sh $f1 $f2 $d ./$dataDir/
		fi
	fi
done

