##########
# Given a database directory (w/ database.txt) 
# for all files from database.txt - find points with BIM
##########
import os, re, subprocess, shlex, sys

if len(sys.argv)==3:
	dataDir = sys.argv[1]
	nPoints = sys.argv[2]
else:
    print "Usage: python UseBIMToFindPoints.py DataDir npts"
    exit()

print "Finding ", nPoints ," points on ", str(dataDir);

f = open(str(dataDir) + '/database.txt', 'r')
dbTxt = f.read()

mNames=re.findall("ModelName\t(.*?)\n", str(dbTxt))

scriptPath=os.path.dirname(sys.argv[0])

for mName in mNames:
	modelFile=str(dataDir) + "/Models/" + str(mName)+"/Geometry/"+str(mName)+".ply"
	params=modelFile+" "+str(nPoints) + " " + str(dataDir) + "/BIM/"
	pntsFile=str(dataDir)+"/BIM/" + str(mName)+"/Blended_"+str(mName)+".smplset.even"
	pntsFile2=str(dataDir)+"/Models/" + str(mName)+"/PointSets/ConnectedPointCloud.pnts"

	if (not os.path.exists(pntsFile)) and (not os.path.exists(pntsFile2)):
		os.system(str(scriptPath) + "/FindPoints.sh "+str(params))


