#!/bin/bash

if [ $# -le 3 ]; then
	echo "Usage: "
	echo "	./convertAllFilesInDir.sh inputDir inputExt outputDirectory outputExtension [optional scriptPath]"
	echo "	Converts all files in the input directory to the output extension"
	echo ""
	exit
fi

inputDir=$1
inputExt=$2
outputDir=$3
outputExt=$4
if [ $# -ge 5 ]; then
    scriptPath=$5
else
    mypath="`dirname \"$0\"`"
    scriptPath=$mypath"/"
fi

if [ outputExt == ".dae" ]; then
	tempDir="$outputDir"
else
	tempDir="$outputDir"_TempDir
fi
outputSubdirs="true"		# for formats that have multiple files

if [ ! -d $outputDir ]; then
	mkdir $outputDir
fi

if [ "$tempDir" != "$outputDir" ]; then
    if [ -d $tempDir ]; then
        rm -r $tempDir
    fi

    mkdir $tempDir
fi


echo "" > "$outputDir/"database.txt

for file in `ls -1 $inputDir/*`
do
	echo "--------------"
	echo "Processing $file"
	
	nopath=`basename $file`
	extOnly="."`echo "$nopath" | cut -d'.' -f2`
	fileOnly=`echo "$nopath" | cut -d'.' -f1`

	if [ $extOnly == ".zip" ]; then
		mkdir $tempDir/$fileOnly
		cp $file $tempDir/$fileOnly
        currDir=`pwd`
		cd $tempDir/$fileOnly
		unzip $nopath
		rm $nopath
		cd $currDir

        if [ -f $tempDir/$fileOnly/models/*$inputExt ]; then
			if [ ! -d $outputDir/$fileOnly ]; then
				mkdir $outputDir/$fileOnly
			fi
			echo "$fileOnly:" >> "$outputDir/"database.txt
			echo "	EntryType	[ColladaStyle]" >> "$outputDir/"database.txt
			echo "	Filepath	[$fileOnly/models/$fileOnly$outputExt]" >> "$outputDir/"database.txt
					
			$scriptPath/convertAutoRecognizeDir.sh "$tempDir/$fileOnly" "$outputDir/$fileOnly" "$fileOnly$outputExt"
        fi
	else
		echo "	Unknown extension: $extOnly"
	fi
done




