#!/bin/bash

if [ $# -ne 3 ]; then
	echo "Usage: "
	echo "	./convertAutoRecognizeDir modelDirInput modelDirOutput modelFileOutput"
	echo ""
	exit
fi

currDir=`pwd`

dirIn=$1
dirOut=$2
outFile=$3

IFS=$'\n'

outNopath=`basename $outFile`
outExtOnly="."`echo "$outNopath" | cut -d'.' -f2`
outFileOnly=`echo "$outNopath" | cut -d'.' -f1`


if [ -f $dirIn/models/*.dae  ]; then		# collada
	for file in `ls -1 $dirIn/models/*.dae`
	do
        if [ ! -d $dirOut/models ]; then
        mkdir $dirOut/models
        fi
		if [ ".dae" != "$outExtOnly" ]; then		
            echo "MESHLAB parsing"
			./convertMeshlab.sh "$file" "$dirOut/models/$outFile"
            #if [ -d $dirIn/images ]; then
            #	cp -r $dirIn/images $dirOut/
            #fi
		else
			mv "$file" $dirOut/models/$outFile
		fi
	done
else
	echo "Cannot find a model file in $dir1"
fi

