##########
# This is Google Warehouse crawler. For a given search query (keyword) 
# it downloads the first maxNumModels models after the a given ID (start) 
# and prints them into keywordDir/keywordDir(ID).zip
#
# >>>>>>>>>>>>>>>>>>> It only downloads COLLADA models >>>>>>>>>>>>>>>>>>>>>>
##########
import os, re, subprocess, shlex, sys, datetime

if len(sys.argv)==4:
    keyword        = sys.argv[1]
    keywordDir     = sys.argv[2]
    #keywordDir="model"
    maxNumModels   = int(sys.argv[3])
elif len(sys.argv)==0:
    #keyword="chair"
    #keywordDir="chairCollada"
    keyword         = "car"
    keywordDir      = "carCollada"
    maxNumModels    = 100
else :
    print "Usage: python crawler.v2.py keyword outDir nModels"
    exit()

print "Searching for ", maxNumModels, " ", keyword, " write to ", keywordDir

MAX_SIZE=1000000

nFound=0
start=0
infoText="Readme.txt"
downloadedModels=[]
excludeAuthor="SmartFurniture.com"

sketchup="http://sketchup.google.com"
warehouse=sketchup+"/3dwarehouse/"
os.system("mkdir "+keywordDir)
os.system("echo \"\" > "+keywordDir+"/"+infoText)


def parseSearchFile(searchString, globalCounter):
	downloadPages = re.findall("<span id=\"bylinetitle\" class=\"normal\"><a href=\"/3dwarehouse/details\?mid=(.*?)\"", searchString)
	
	currBegin = re.findall("Results  <b>(.*?)</b>", searchString)
	currEnd = re.findall("</b>  -  <b>(.*?)</b> ", searchString)
	currMax = re.findall("of about  <b>(.*?)</b>", searchString)
	
	if len(currMax)==0:
		currMax.append("1000");		# 1000 is maximal number of models returned by GW
	
	dataExists = len(downloadPages)
	items=0
	
	# check if can find boundaries
	if len(currBegin)==0:
		fname="F"+str(failedCounter)+".html"
		os.system("echo \"<a href=./"+fname+">Cannot understand limits (begin)</a><br>\" >> "+failFile)
		f = open(failedDir+"/"+fname, "w");
		f.write(str(searchString));
		f.close();
		failedCounter=failedCounter+1
		return (0, globalCounter, items, failedCounter)
	
	if len(currEnd)==0:
		fname="F"+str(failedCounter)+".html"
		os.system("echo \"<a href=./"+fname+">Cannot understand limits (end)</a><br>\" >> "+failFile)
		f = open(failedDir+"/"+fname, "w");
		f.write(str(searchString));
		f.close();
		failedCounter=failedCounter+1
		return (0, globalCounter, items, failedCounter)

	print "Results "+currBegin[0]+"-"+currEnd[0]+" of "+currMax[0]
	if int(currBegin[0])==int(currEnd[0]):
		return (0, globalCounter, items)		

	if int(start)>=int(currMax[0]):
		return (0, globalCounter, items)

	for s in downloadPages:
		authorName = re.findall("mid="+s+"(.*?)\"author\" target=\"_self\">(.*?)</a>", searchString);
		
		items = items+1
		
		exclude=0
		if excludeAuthor==authorName[0][1]:
			exclude=1

		if exclude==0:
			fileURL1=sketchup+"/3dwarehouse/details?mid="+s

			subPID = subprocess.Popen(shlex.split("curl \""+fileURL1+"\""), shell=False, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
			currObj, errors = subPID.communicate()
			
			fileURL2=re.findall("<tr><td>Collada \(\.zip\)</td>\n<td>\[ <a class=\"download\" href=\"(.*?)\" onclick", str(currObj))
			
			if len(fileURL2)>0:
				revisedURL=sketchup+re.sub("amp;", "", fileURL2[0])

				subPID1 = subprocess.Popen(shlex.split("curl \""+revisedURL+"\""), shell=False, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
				currObj1, errors = subPID1.communicate()
				
				fileURL3=re.findall("<A HREF=\"(.*?)\">here", str(currObj1))

				if len(fileURL3)>0:
					#finalURL = re.sub("amp;", "", sketchup+fileURL3[0])
					finalURL=fileURL3[0]
					if globalCounter<10:
						gcStr="000"+str(globalCounter)
					elif globalCounter<100:
						gcStr="00"+str(globalCounter)
					elif globalCounter<1000:
						gcStr="0"+str(globalCounter)
					else:
						gcStr=str(globalCounter)				
				
					modelname=keywordDir+"/model"+gcStr+".zip"
					os.system("curl \""+finalURL+"\" >> "+modelname)
					
					if sys.platform=="darwin":
						cmd="md5 \""+modelname+"\""
					else:
						cmd="md5sum \""+modelname+"\""
					checksumID = subprocess.Popen(shlex.split(cmd), shell=False, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
					checksumObj, errors = checksumID.communicate()
					if sys.platform=="darwin":
						checksum = re.findall(" = (.*?)\n", str(checksumObj))
					else:
						checksum = re.findall("(.*?) ", str(checksumObj))
					modelDownloaded=0
					for dm in downloadedModels:
						if dm==checksum[0]:
							modelDownloaded=1
							break;
					
					if modelDownloaded==0:
						downloadedModels.append(checksum[0]);
				
					stat = os.stat(modelname);
					if stat.st_size > MAX_SIZE and modelDownloaded==0:
						print "[WARNING] Model is too big (ignoring): " + str(stat.st_size)

					if modelDownloaded!=0:
						print "[WARNING] Model with the same checksum already downloaded (ignoring): " + str(checksum[0]) 
						
					if modelDownloaded==0 and stat.st_size < MAX_SIZE:
						os.system("echo Model"+gcStr+": >> "+keywordDir+"/"+infoText)
						os.system("echo \"\tFormat \t\t\t [Collada]\" >>"+keywordDir+"/"+infoText)
						os.system("echo \"\tURL \t\t\t ["+finalURL+"]\" >>"+keywordDir+"/"+infoText)
						os.system("echo \"\tKeywords \t\t\t ["+keyword+"]\" >>"+keywordDir+"/"+infoText)
						os.system("echo \"\tDirname \t\t\t ["+keywordDir+"]\" >>"+keywordDir+"/"+infoText)
						os.system("echo \"\tModelID \t\t\t ["+str(globalCounter)+"]\n\" >>"+keywordDir+"/"+infoText)
						globalCounter = globalCounter+1
						if globalCounter >= maxNumModels:
							break;
					else:
						os.system("rm "+modelname)		
	return (dataExists, globalCounter, items)

def prevDate(currMonth, currYear):
	if currMonth>1:
		currMonth=currMonth-1
	else:
		currMonth=12
		currYear=currYear-1
	return (currMonth, currYear)

def get2DigStr(twoDigitInt):
	if len(str(twoDigitInt))<2:
		return "0"+str(twoDigitInt)
	else:
		return str(twoDigitInt)

# first: search without date
searchNoDate=True
# repeat for different time periods
currYear=datetime.date.today().year-2000
currMonth=datetime.date.today().month	
endYear=05

items=0

while nFound < maxNumModels:
	if searchNoDate==True:
		query=warehouse+"search?q=title%3A"+keyword+"+is%3Amodel+filetype%3Azip"
		query=query+"&styp=m&scoring=t&btnG=Search&start="+str(start)
	else:
		nextMonth=get2DigStr(currMonth)
		nextYear=get2DigStr(currYear)
		(prevMonthInt, prevYearInt) = prevDate(currMonth, currYear)
		prevMonth=get2DigStr(prevMonthInt)
		prevYear=get2DigStr(prevYearInt)
		
		query=warehouse+"search?q=title%3A"+keyword
		query=query+"+after%3A%22"+prevMonth+"%2F01%2F"+prevYear+"%22"
		query=query+"+before%3A%22"+nextMonth+"%2F01%2F"+nextYear+"%22"
		query=query+"+is%3Amodel+filetype%3Azip&styp=m&scoring=t&btnG=Search&start="+str(start)

	subPIDMain = subprocess.Popen(shlex.split("curl \""+query+"\""), shell=False, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
	searchString, errors = subPIDMain.communicate()
		
	print query
	
	(dataExists, nFound, items) = parseSearchFile(searchString, nFound)
	
	print "\n\nFOUND "+str(nFound)+" MODELS. Start " + str(start) 

	if searchNoDate==True:
		print "  BEST RESULTS SEARCH \n\n"
	else:
		print "  DATE-based SEARCH (M/Y):"+str(currMonth)+"/"+str(currYear)+"\n\n"

	start = start+items

	if dataExists == 0 or items == 0:
		if searchNoDate==True:
			searchNoDate=False
		else:
			(prevMonthInt, prevYearInt) = prevDate(currMonth, currYear)
			if prevYearInt >= endYear:
				start=0
				currMonth=prevMonthInt
				currYear=prevYearInt
			else:
				print "[WARNING] Search ended prematurely - couldn't find more models"
				break
	

#print query


