#!/bin/bash
# !/bin/sh


###### MATLAB #####
#matlabPath="/Applications/MATLAB_R2010a.app/bin/"
#matlabPath="/Applications/MATLAB_R2008a/bin/"
#PATH="$PATH:$matlabPath"
#export PATH

#./RecompileAll.sh
if [ $# -lt 1 ]; then
    echo "After running this script you will see an empty database "
    echo "    press ';' then type a keyword followed by '#', number"
    echo "    of desired models, '#', select source (e.g. 1 - google)"
    echo "Press \` for more options"
    echo ""
    echo "Usage: "
    echo "	./ProcessDB dbName [optional: Keyword NModels Database ModelsToKeep]"
    echo ""
    exit
fi

dbName=$1
keyword="none"
nModels=0
srcDatabase="none"
modelsToKeep="all"

if [ $# -gt 4 ]; then
	keyword=$2
	nModels=$3
	srcDatabase=$4
	modelsToKeep=$5
#echo "	keep=[$modelsToKeep]"
	params="$params -Pipeline Visualize false"
fi


params="$params -LoadDatabase INPUT_DataDirs $dbName OUTPUT_DBDir $dbName"
params="$params -CreateDBApp INPUT_Keyword $keyword INPUT_NModels $nModels"
params="$params -CreateDBApp INPUT_SrcDB $srcDatabase INPUT_ModelsToKeep [$modelsToKeep]"

./`uname`_`uname -m`_DatabaseVis settingsEditDB.txt $params
