#!/bin/bash

if [ $# -lt 4 ]; then
	echo "Usage: "
	echo "	./MonitorBIMBatch processID dir maxBIMDist runJobsAs=[qsubEach execOneByOne]"
	echo ""
	exit
fi

ID=$1
monitorFile=$2/BIM/BIMBatch.txt
bimMaxDist=$3
runJobsAs=$4

sleepTime=5
maxTime=28800

while [ $maxTime -ge 0 ]; do
	sleep $sleepTime"s"
	let maxTime=$maxTime-$sleepTime
	if [ $runJobsAs == "qsubEach" ]; then
		nIDs=`qstat $ID | grep -c vk`
		if [ $nIDs -eq 0 ]; then
			break;
		fi
	fi

	if [ -f $monitorFile ]; then
		sleep $sleepTime"s"	# just in case file is not dumped yet
		../BIM/RunBIMBatch.sh $monitorFile $bimMaxDist $runJobsAs
		rm $monitorFile
	fi
done


