#!/bin/bash

# NOTE: this file creates a shape desciptor for a model.
# Feel free to use any shape descriptor (output should be a 
# binary signature, integer N + N floating (single-point) numbers
# This is further used in fuzzy correspondence computation.
#gapsBin=../../external/gaps/bin/`uname -m`/msh2shd
gapsBin=./ShapeDescriptors/`uname`_`uname -m`_msh2shd

if [ $# -ge 2 ]; then
	inModel=$1
	outDescriptor=$2
else
	echo "============="
	echo "	Usage: $0 inputModel descriptorFile [optional: pnts]"
	echo "============="
	exit
fi


params=""
if [ $# -ge 3 ]; then
	params="-points $3 -sigma 1.5 "
fi

$gapsBin $1 $2 $params -normalize 2




